class LSystem{
 String axiom;
 String computedWord;
 String[][] rules;
                    
 String[][] abstractFractal1 = {{"L", "L[-R][+R]"},              
                    {"R", "L[-R]L[+L-R]"},
                    {"+", "+","+"},
                    {"-","-","-","-"},
                    {"[", "[","[","["},
                    {"]","]","]","]"}};
 String[][] abstractFractal2 = {{"L", "R+L+R[+R]R[-L]RRL"},              
                    {"R", "L-R-[+R]LR[-RL]LR"},
                    {"+", "+","+"},
                    {"-","-","-","-"},
                    {"[", "[","[","["},
                    {"]","]","]","]"}};
 String[][] abstractFractal3 = {{"F", " [F]-F-F+[+F]+F-F"}, 
                    {"+", "+","+"},
                    {"-","-","-","-"},
                    {"[", "[","[","["},
                    {"]","]","]","]"}};
                                         
 String[][] botanical = {{"X" , "F-[[X]]+F[+FX]-X",  "F[+F]F[-F][F]X" , "F[+FX][-XF]FX"}, 
                    {"F", "FF", "F", "FF"},
                    {"+", "+","+","+"},
                    {"-","-","-","-"},
                    {"[", "[","[","["},
                    {"]","]","]","]"}};      
                    
 String[][] shapes = {{"A", "A-B--B+A++AA++B-"}, 
                    {"B", "+A-BB--B-A++A++B"},
                    {"+", "+","+"},
                    {"-","-","-","-"},
                    {"[", "[","[","["},
                    {"]","]","]","]"}}; 
                    
 String[][] cutOut = {{"Y" , "B-[[Y]]+B[+BY]-Y"}, 
                    {"B", "BB", "B", "BB"},
                    {"+", "+","+","+"},
                    {"-","-","-","-"},
                    {"[", "[","[","["},
                    {"]","]","]","]"}};
 float size, angle;
 int totalIteration;
 
  
 LSystem(float size, float angle, String axiom, String name){
   this.size = size;
   this.angle = angle;
   this.axiom = axiom;
   computedWord = axiom;
   if(name == "abstractFractal1"){
     rules = abstractFractal1;
   }
   else if(name == "abstractFractal2"){
     rules = abstractFractal2;
   }
   else if(name == "abstractFractal3"){
     rules = abstractFractal3;
   }
   else if(name == "botanical"){
     rules = botanical;
   }
   else if(name == "shapes"){
     rules = shapes;
   }
   else if(name == "cutOut"){
     rules = cutOut;
   }
 }
 
 void setRules(String[][] rules){
  this.rules = rules; 
 }
 
 
 void setAxiom(String axiom){
   this.axiom = axiom;
 }
 

 void iterate(int iterations){
  String tempWord;
  println(computedWord);
  for(int i = 0; i<iterations; i++){
    tempWord = computedWord;
    computedWord = "";
    for(int j=0; j<tempWord.length();j++){
      char c = tempWord.charAt(j);
      for(int k = 0; k<rules.length;k++){
        if(c == rules[k][0].charAt(0)){
          computedWord = computedWord + rules[k][1];
          break;
        }
      }
    }
    println("iteration " +i + ": " + computedWord);
  }
 }
 
 
 void iterateRandom(int iterations){
  String tempWord;
  println(computedWord);
  for(int i = 0; i<iterations; i++){
    tempWord = computedWord;
    computedWord = "";
    for(int j=0; j<tempWord.length();j++){
      char c = tempWord.charAt(j);
      for(int k = 0; k<rules.length;k++){
        if(c == rules[k][0].charAt(0)){
          computedWord = computedWord + rules[k][(int)random(1,3)];
          break;
        }
      }
    }
    println("iteration " +i + ": " + computedWord);
  }
 }
 
 
 
 
float[] polarPoint(float r, float angle){
 float[] point = new float[2];
 point[0] = r*cos(radians(angle))+t.getX();
 point[1] = r*sin(radians(angle))+ t.getY();
 return point;
}


void plot(){
  float r;
  stroke(255,0,0);
  fill(255,0,0);
  beginShape();
  for(float i = 0; i<700; i++){
   r = 6 * cos(radians(i*4));//this make a flower with center point
   float[] point = polarPoint(r,i);
   curveVertex(point[0], point[1]);
  }
  endShape();
}



 int flag =0;
 void drawSystem(Turtle t){
  strokeWeight(4);
  for(int i = 0; i<computedWord.length(); i++){
    char c = computedWord.charAt(i); 
    if( c =='F'){
      stroke(13, 234, 197 );
      t.forward(size);
    }
    else if( c =='B'){
      //stroke(13, 234, 197 );
      t.forward(size);
    }
    else if (c == 'X'){
      if(flag == 0){
        plot();
        flag = 1;
      }
     fill(255,0,0); 
     ellipse(t.getX(), t.getY(), size/2, size/2);
     noFill();
    }
    else if (c == 'L'){
     stroke(204, 102, 0);
     t.forward(size); 
    }
    else if (c == 'R'){
      stroke(200,166,11);
     t.forward(size); 
    }
    else if (c == 'A'){
     stroke(198, 188, 146);
     t.forward(size); 
    }
    else if (c == 'B'){
     stroke(198, 188, 146);
     t.forward(size); 
    }
    else if (c == '+'){
     t.right(angle);
    }
    else if (c == '-'){
     t.left(angle);  
    }
    else if (c == '['){
     t.push();
     flag = 0;
    }
    else if (c == ']'){
     t.pop();
    }
  }
 }
}
