import Turtle.*;
import processing.pdf.*;

/*****************************************
 * Large Assignment 1: L-System Lace
 * Name:    Ruby Ta
 * E-mail:  nta@unm.edu
 * Course:      CS491, Computational Fabrication
 * Submitted:    2/10/2022
 *
 * Uncomment these lines below in the mouseClicked() 
 * function to run each part of the program
***********************************************/


LSystem l;
Turtle t;

void setup(){
 size(900,900);
}

void draw(){
}

void mouseClicked(){
 //background(0);
 background(0xFFFFFFFF);
 t = new Turtle(this);
 
 //beginRecord(PDF, "cutout.pdf");//second()
 
 //**********COMMENT OUT ANY COMMAND BELOW TO RUN THE CODE********************
 //***********Abstract fractal***************
 //abstractFractal1();
 //abstractFractal2();//change rules in LSystem
 //abstractFractal3();
 
 
 //********** For botanical form ************
 //botanical();

 //********** Shapes other than simple lines ************
 //shapes();
 

 //********** A Rogan Brown inspired cut out ************
 cutout(); 

 //endRecord();
}


void abstractFractal1(){
 background(0);
 t.penUp();
 t.back(height/5);
 t.penDown();
 l = new LSystem(33,30,"L", "abstractFractal1");
 l.iterate(8);
 l.drawSystem(t);
}

void abstractFractal2(){
 background(0);
 t.penUp();
 t.back(height/3);
 t.penDown();
 l = new LSystem(15,60,"L", "abstractFractal2");
 l.iterate(3);
 l.drawSystem(t);
}

void abstractFractal3(){//commend out color stroke in F
 background(0);
 l = new LSystem(28,20,"F", "abstractFractal3");
 l.iterate(5);
 l.drawSystem(t);
}


void botanical(){
 background(0);
 int deg = 0;
 int branch = 10;
 for(int i = 0; i<branch; i++){
   l = new LSystem(10,25,"X", "botanical");
   l.iterateRandom(5);
   l.drawSystem(t);
 
   t.penUp();
   t.goToPoint (height/2, width/2);
   deg = deg + 360/branch;
   t.setHeading(deg);
   t.penDown();
 }
}


void shapes(){
 background(0);
 t.penUp();
 t.goToPoint(width/10, height/10);
 t.penDown();
 l = new LSystem(13,60,"A", "shapes");
 l.iterate(4);
 l.drawSystem(t);
}

float[] polarPoint(float r, float angle){
 float[] point = new float[2];
 point[0] = r*cos(radians(angle))+t.getX();
 point[1] = r*sin(radians(angle))+ t.getY();
 return point;
}


void plot(){
  float r;
  stroke(255,0,0);
  fill(255,0,0);
  beginShape();
  for(float i = 0; i<400; i++){
   r = 22 * cos(radians(i*4));//this make a flower with center point
   float[] point = polarPoint(r,i);
   curveVertex(point[0], point[1]);
  }
  endShape();
}
